﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7.3
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Private manager As BleManager2
	Public connectedCentrals As Map
	Private peripheral As BlePeripheral2
	Public NotAvailable As Boolean
	Private NativeMe As JavaObject
	
	Private b() As Byte
End Sub

Sub Service_Create
	NativeMe.InitializeContext
	manager.Initialize("manager")
	connectedCentrals.Initialize
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

'protected void setAdvertiseData() {
'
'     AdvertiseData.Builder mBuilder = new AdvertiseData.Builder()
'
'     ByteBuffer mManufacturerData = ByteBuffer.allocate(23);
'
'     byte[] uuid = getIdAsByte(UUID.fromString("0CF052C297CA407C84F8B62AAC4E9020"));
'
'     mManufacturerData.put(0, (byte)0x02);
'     mManufacturerData.put(1, (byte)0x15); 
'
'     For (int i=2; i<=17; i++) {
'       mManufacturerData.put(i, uuid[i-2]); // adding the UUID
'     }
'
'     mManufacturerData.put(18, (byte)0x00); // first byte of Major
'     mManufacturerData.put(19, (byte)0x09); // second byte of Major
'     mManufacturerData.put(20, (byte)0x00); // first minor
'     mManufacturerData.put(21, (byte)0x06); // second minor
'     mManufacturerData.put(22, (byte)0xB5); // txPower
'
'     mBuilder.addManufacturerData(76, mManufacturerData.array()); 
'     mAdvertiseData = mBuilder.build();
'}

Private Sub Manager_StateChanged (State As Int)
	Dim bc As ByteConverter
    If State <> manager.STATE_POWERED_ON Then
        ToastMessageShow("Please enable Bluetooth", True)
        NotAvailable = True
    Else
        peripheral.Initialize("peripheral", manager)
        
		Dim bb As B4XBytesBuilder 'B4XCollections
		bb.Initialize
		bb.Append(Array As Byte(0x02, 0x15))
		Dim bc As ByteConverter
		bb.Append(bc.HexToBytes("0CF052C297CA407C84F8B62AAC4E9020"))
		bb.Append(Array As Byte(0, 9, 0, 6, 0xb5))
'		Dim b() As Byte = bb.ToArray
		b = bb.ToArray

		peripheral.ManufacturerData = CreateMap(76: b )

'		For i = 0 To peripheral.ManufacturerData.Size - 1
'			Log("Key: " & peripheral.ManufacturerData.GetKeyAt(i))
'			Log("Value: " & bc.HexFromBytes ( peripheral.ManufacturerData.GetValueAt(i))  )
'		Next


		If peripheral.IsPeripheralSupported = False Then
            ToastMessageShow("Peripheral mode not supported.", True)
            NotAvailable = True
        Else
 			peripheral.Start2("SVO_Beacon", CreateAdvertiseSettings)
'            peripheral.Start("B4APeripheral")
            Wait For Peripheral_Start (Success As Boolean)
            Log("Peripheral started successfully? " & Success)
        End If
    End If
	SetState(False)


End Sub

Private Sub CreateAdvertiseSettings  As Object
	Dim builder As JavaObject
	builder.InitializeNewInstance("android.bluetooth.le.AdvertiseSettings.Builder", Null)
	builder.RunMethod("setConnectable", Array(True))
	builder.RunMethod("setAdvertiseMode", Array(2)) 'ADVERTISE_MODE_LOW_LATENCY
	builder.RunMethod("setTxPowerLevel", Array(3)) 'ADVERTISE_TX_POWER_HIGH
	Return builder.RunMethod("build", Null)
End Sub
'
'
'Private Sub CreateAdvertiseData As Object
'	Dim builder As JavaObject
'	builder.InitializeNewInstance("android.bluetooth.le.AdvertiseData.Builder", Null)
'	builder.RunMethod("setIncludeTxPowerLevel", Array(False)) 
'	builder.RunMethod("setIncludeDeviceName", Array(False)) 
'	builder.RunMethod("addManufacturerData", Array (0x4c, b) )
'	Return builder.RunMethod("build", Null)
'End Sub


Sub Peripheral_Subscribe (CentralId As String)
	connectedCentrals.Put(CentralId, "")
	Log("Connected: " & connectedCentrals.Get(CentralId))
	SetState(True)
End Sub

Sub Peripheral_Unsubscribe(CentralId As String)
	connectedCentrals.Remove(CentralId)
	Dim connected As Boolean = connectedCentrals.Size > 0
	SetState(connected)
End Sub

Sub Peripheral_NewData (DeviceId As String, Data() As Byte)
	peripheral.Write(Null, Data) 'send the message to all subscribed centrals (this can be removed for one to one connections).
	CallSub2(Main, "NewMessage", Data)
End Sub

Sub SendMessage (msg() As Byte)
	peripheral.Write(Null, msg)
End Sub

Sub SetState (Connected As Boolean)
	CallSub2(Main, "SetState", Connected)
End Sub


'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

